3 # Copyright (c) 2005 Junio C Hamano
6 test_description='the test framework itself.'
8 ################################################################
9 # It appears that people try to run tests without building...
11 if ! test -x ../notmuch
13 echo >&2 'You do not seem to have built notmuch yet.'
19 ################################################################
21 test_expect_success 'success is reported like this' '
24 test_set_prereq HAVEIT
26 test_expect_success HAVEIT 'test runs if prerequisite is satisfied' '
27 test_have_prereq HAVEIT &&
32 test_expect_success 'tests clean up after themselves' '
33 test_when_finished clean=yes
37 test_expect_code 1 'tests clean up even after a failure' '
38 test_when_finished cleaner=yes &&
42 if test $clean$cleaner != yesyes
44 say "bug in test framework: cleanup commands do not work reliably"
48 test_expect_code 2 'failure to clean up causes the test to fail' '
49 test_when_finished "(exit 2)"
52 # Ensure that all tests are being run
53 test_begin_subtest 'Ensure that all available tests will be run by notmuch-test'
54 tests_in_suite=$(grep TESTS= ../notmuch-test | sed -e "s/TESTS=\"\(.*\)\"/\1/" | tr " " "\n" | sort)
55 available=$(ls -1 ../ | grep -v -E "^(aggregate-results.sh|Makefile|Makefile.local|notmuch-test|README|test-lib.sh|test-results|tmp.*|valgrind|corpus*|emacs.expected-output|smtp-dummy|smtp-dummy.c)" | sort)
56 test_expect_equal "$tests_in_suite" "$available"
58 ################################################################
59 # Test mail store prepared in test-lib.sh
62 'test that mail store was created' \
63 'test -d "${MAIL_DIR}"'
66 find "${MAIL_DIR}" -type f -print >should-be-empty
68 'mail store should be empty' \
69 'cmp -s /dev/null should-be-empty'
72 'NOTMUCH_CONFIG is set and points to an existing file' \
73 'test -f "${NOTMUCH_CONFIG}"'
76 'PATH is set to this repository' \
77 'test "`echo $PATH|cut -f1 -d: | sed -e 's,/test/valgrind/bin$,,'`" = "`dirname ${TEST_DIRECTORY}`"'